/*
This file is a part of the Leadtek Flash-OFDM driver, driver version: f.ff.f1.31 (january_wip3)

Copyright  2010 Leadtek Reseach Inc.

This program is free software; you may redistribute it and/or modify it under the terms of the GNU General
Public Licence as published by the Free Software Foundation; either version 2 [or version 3 or any other
relevant GPL licence type] of the Licence, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
Please see the GNU General Public Licence for more details.
You should have received a copy of the GNU General Public Licence along with this program; if not, please
write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.

Leadtek Research Inc.
18F, NO. 166, CHIEN-YI ROAD, CHUNG-HO CI
TAIPEI  HSIEN
Taiwan (23511), R. O. C
*/
/*
# History:
# -- Date ------ Who ------ Version ------- Note -----------------------------
# 2010.10.04	Jeffxing	0v200	LTK_official_release_2_3_2010_based_on_january_wip3 
# 2009.10.27	Jeffxing	0v099	October09 Ivan final code. 
#					Changes from the cheesecake release:
#					- Cleaned up, 
#					- Support up to the network kernels, 
#					- Change the license to GPL
# ----------- History End ----------------------------------------------------
*/ 

#ifndef _FT1000_HW_H_
#define _FT1000_HW_H_

#include "ft1000_usb.h"

extern u16 ft1000_read_register(struct usb_device *dev, PUSHORT Data, u8 nRegIndx);
extern u16 ft1000_write_register(struct usb_device *dev, USHORT value, u8 nRegIndx);

#endif
