#!/bin/sh

modprobe ipsec
/libexec/ipsec/tncfg --attach --virtual ipsec0 --physical eth1
ifconfig ipsec0 192.168.122.238 netmask 255.255.255.0 mtu 1400
/libexec/ipsec/pluto --nofork --use-klips --nat_traversal --secretsfile /etc/ipsec.secrets &
sleep 3
/libexec/ipsec/whack --name 0  --host 192.168.122.238 --client 192.168.123.0/255.255.255.0 --to  --host 192.168.122.237 --client 192.168.122.237/255.255.255.255  --psk --rekeymargin 10 --rekeyfuzz 100  --encrypt --ikelifetime 14400 --ipseclifetime 14400 --delete --keyingtries 1 --ike=3des-sha1-modp1024 --esp 3des-sha1
/libexec/ipsec/whack --listen
/libexec/ipsec/whack --route --name 0
echo 0 > /proc/sys/net/ipsec/txdrop_rate
echo 0 > /proc/sys/net/ipsec/rxdrop_rate
